;application.s
		

%include "tlib/tmacros.inc"

bits 32
org 0x15000


	;jmp to on Ctrl+F12
	mov dword [0x508],main

	;register app hooks
	;these functions are called by keyboard and mouse irq's
    mov [LBUTHOOK],dword leftbut
    mov [RBUTHOOK],dword rightbut
    mov [MBUTHOOK],dword middlebut
    mov [PAINT],dword paint
    mov [MMOVEHOOK],dword mousemove


	call paint




main:

	call [GETC]
	;returns ascii keypress in al

	cmp al,'c'
	jz near .readpcispace
	cmp al,'u'
	jz near .readusbspace
	cmp al,'r'
	jz near .resetcontroller
	cmp al,'e'
	jz near .resetenableport0
	cmp al,'a'
	jz near .setaddress
	cmp al,'d'
	jz near .getdevicedescriptor
	cmp al,'g'
	jz near .getconfigdescriptor
	cmp al,'j'
	jz near .getconfiginterfaceendpointdescriptors
	cmp al,'k'
	jz near .setconfiguration
	cmp al,'b'
	jz near .bulkresetrecovery
	cmp al,'z'
	jz near .runscsireadcapacity
	cmp al,PAGEDN  
	jz near .nextpage
	cmp al,PAGEUP
	jz near .previouspage
	cmp al,'0'
	jz near .zerotd
	cmp al,'l'
	jz near .getconfiguration
	cmp al,'m'
	jz near .getmaxlun
	cmp al,'t'
	jz near .testunitready
	cmp al,'q'
	jz near .inquiry
	cmp al,'1'
	jz near .read10cbw
	cmp al,'2'
	jz near .readdata
	cmp al,'3'
	jz near .read10csw
	cmp al,'5'
	jz near .write10cbw
	cmp al,'6'
	jz near .writedata
	cmp al,'7'
	jz near .write10csw
	cmp al,'v'
	jz near .clearbulkin
	cmp al,'w'
	jz near .clearbulkout
	cmp al,'s'
	jz near .requestsense

	
	jmp .endmain




.nextpage:
	inc dword [page]
	jmp .endmain

	
.previouspage:
	cmp dword [page],0
	jz near .endmain
	dec dword [page]
	jmp .endmain


.resetcontroller:
	mov dword [feedback],str41
	call resetuhcicontroller
	jmp .endmain


.resetenableport0:
	mov dword [feedback],str36
	call resetport0
	jmp .endmain


.setaddress:
	mov dword [feedback],str48
	call SetAddress
	jmp .endmain


.readpcispace:
	mov dword [feedback],str27
	call readpcispace
	jmp .endmain


.readusbspace:
	mov dword [feedback],str15
	call readusbspace
	jmp .endmain


.getdevicedescriptor:
	mov dword [feedback],str49
	call GetDeviceDescriptor
	jmp .endmain


.getconfigdescriptor:
	mov dword [feedback],str54
	mov edx,9
	call GetConfigDescriptor
	jmp .endmain


.getconfiginterfaceendpointdescriptors:
	;this should be run immediately after the above
	mov dword [feedback],str55
	movzx edx, word [wTotalLength] 
	call GetConfigDescriptor
	jmp .endmain


.setconfiguration:
	mov dword [feedback],str56
	call SetConfiguration
	jmp .endmain


.getconfiguration:
	mov dword [feedback],str76
	call GetConfiguration
	jmp .endmain


.runscsireadcapacity:
	mov dword [feedback],str70
	call ReadCapacity
	jmp .endmain


.bulkresetrecovery:
	mov dword [feedback],str68
	call BulkOnlyMassStorageReset
	mov eax,10
	call [SLEEP]
	call ClearBulkIn
	mov eax,10
	call [SLEEP]
	call ClearBulkOut
	jmp .endmain


.zerotd:
	mov dword [feedback],str75
	mov dword [qtydevicedata],0	
	mov dword [tdCommand+4],0
	mov dword [tdData+4],0
	mov dword [tdStatus+4],0
	MAC_MEMSET scsiCSW,0,13,b
	jmp .endmain


.getmaxlun:
	mov dword [feedback],str72
	call GetMaxLun
	jmp .endmain


.testunitready:
	mov dword [feedback],str78
	call TestUnitReady
	jmp .endmain


.inquiry:
	mov dword [feedback],str86
	call Inquiry
	jmp .endmain
	
	
.read10cbw:
	mov dword [feedback],str80
	call Read10CBW
	jmp .endmain


.readdata:
	mov dword [feedback],str81
	call ReadData
	jmp .endmain
	

.read10csw:
	mov dword [feedback],str82
	call Read10CSW
	jmp .endmain
	
	
.write10cbw:
	mov dword [feedback],str83
	call Write10CBW
	jmp .endmain


.writedata:
	mov dword [feedback],str84
	call WriteData
	jmp .endmain
	

.write10csw:
	mov dword [feedback],str85
	call Write10CSW
	jmp .endmain



.clearbulkin:
	mov dword [feedback],str73
	call ClearBulkIn
	jmp .endmain


.clearbulkout:
	mov dword [feedback],str74
	call ClearBulkOut
	jmp .endmain



.requestsense:
	mov dword [feedback],str86
	call RequestSense
	jmp .endmain
	



.endmain:
	call paint
	jmp main



	
paint:
	%include "paint.s"
	ret  


leftbut:
	mov dword [feedback],str2
	call paint
	ret


middlebut:
	mov dword [feedback],str3
	call paint
	ret


rightbut:
	mov dword [feedback],str4
	call paint
	ret


mousemove:
	call paint
	ret



scriptT:   ;20x20
incbin "t.bits"
%include "data.s"
%include "uhcihdwre.s"
%include "usbtransaction.s"



;if you change the times value here
;you must update the boot2.s qty sectors loaded
times 512*100- ($-$$) db 0
