;boot1.s  
;loads boot2.s to 0x600


bits 16
org 7c00h  
	
	cli    ;clear/disable interrupts
	mov ax, 0
	mov ds,ax
	mov es,ax
	mov ss,ax
	mov sp,0xffff
	sti   


	;save drive num  we are booting from
	mov [0x505],dl


	;text mode 80x25, 16 color
	mov ax,0x03
	int 10h


	;welcome
	;you can see these bios boot messages from floppy
	;on fast cdboot I cant see them
	mov si,str1
	call biosprint


	;echo drive num
	mov si,str2
	call biosprint
	mov ax,0
	mov al,[0x505]
	call putax
	mov si,_buf
	call biosprint
	mov si,nl
	call biosprint




readboot2:
	mov bx,0x600    ;memory location for start of boot2
	mov ah,2        ;bios read sector function
	;see times directive at bottom of boot2.s
	;for qty sectors to load
	mov al,7        ;QTY SECTORS TO LOAD=sizeof boot2       
	mov ch,0        ;cylinder
	mov cl,2        ;sector (starting for boot2)
	mov dh,0        ;head
	mov dl,[0x505]  ;drivenum
	int 13h         ;call bios 
	jnc .goto0x600  ;success

	;error-reset disc drive
	mov si,str3
	call biosprint
	mov ah,0
	mov dl,[0x505]
	int 13h
	jmp readboot2


.goto0x600:
	mov si,str4
	call biosprint
	;it is important to specify both seg:off here
	;because I think bios int13 changes the seg
	jmp 0:0x600
	


;put address of null terminated string in si
biosprint: 
	lodsb           ; load byte from si to al and incr 
	or al, al       ; test for 0 terminator
	jz .done_print  ; detect end of string
	mov ah, 0Eh     ; bios function writes char in al
	int 10h         ; call bios 
	jmp biosprint   ; continue until we reach 0
.done_print:
	ret
	
	
;convert contents of ax to ascii hex string in _buf
putax:
	pusha 

	mov bp,0
	rol ax,4
	mov cx,ax ;copy
	and ax,0xf
	mov si,4  ;counter
	
.1:
	;this is the amazing code that does it all
	cmp al,10
	sbb al,69h
	das  ;al contains the ascii char
	
	;move ascii char to our 0 terminated buffer
	mov [_buf+bp],al

	;increment some things
	rol cx,4
	mov ax,cx 
	and ax,0xf  
	add bx,10  ;x+10
	inc bp
	dec si
	jnz .1

	popa
	ret
	
	
_buf times 5 db 0
str1 db 'Welcome to ddusb',10,13,0
str2 db 'Booting from drive number   ',0
str3 db 'Bios int13-2 read disc error-trying again',10,13,0
str4 db 'Jumping to 0x600',10,13,0
nl   db 10,13,0


;bios will only load sector lba=0 (512 bytes)
times 510-($-$$) db 0
dw 0xAA55




