	;getuhci.s
	
	;get bus:dev:function for USB Controller on PCI bus
	;for info see "PCI BIOS SPECIFICATION"
	;we use the bios "FindPCIClassCode" function b103h
	;looking for a UHCI USB Controller (code=0c0300h)

	;zero out
	mov word [0x55c],0 ;qty controllers found
	mov word [0x560],0 
	mov word [0x562],0 
	mov word [0x564],0 
	mov word [0x566],0 
	
	;if there is more than 1 device of the kind
	;you will have to try si=1...
	;my old gateway and CBS computers have only 1 controller
	;each controller controls 2 usb ports
	;my new DELL at work has 4 UHCI controllers with 8 ports
	mov si,0


.findpciclasscode:
	;bios find pci class code
	mov ax, 0xb103

	;test for USB Open Host Controller
	;returns 00 58 00 on toshiba P1 laptop
	;mov ecx,0x000c0310
	
	;test for USB Universal Host Controller
	;since we want to read/write to pen drive with this controller
	;returns 00 3a 00 on CBS P3 custom and Gateway
	;0c=pci base class
	;03=pci subclass
	;00=Universal Host Controller
	mov ecx,0x000c0300
	
	
	;BIOS find pci class code
	;cf is set on error, clear on success
	int 1ah  
	;bh contains the bus
	;bl contains the dev in upper 5 bits and fun in lower 3 bits
	
	;return code, 00=success, 86h=device not found
	cmp ah,86h  ;DEVICE_NOT_FOUND
	jz .initPmode  


	;save the bus:dev:fun of the detected UHCI controller
	cmp word [0x55c],0
	jz .5
	cmp word [0x55c],1
	jz .6
	cmp word [0x55c],2
	jz .7
	cmp word [0x55c],3
	jz .8
	jmp .initPmode

.5: mov [0x560],bx  ;1st controller
	jmp .9
.6: mov [0x562],bx  ;2nd controller
	jmp .9
.7: mov [0x564],bx  ;3rd controller
	jmp .9
.8: mov [0x566],bx  ;4th controller

.9: inc word [0x55c] ;inc qty controllers found
	inc si ;try for next controller
	jmp .findpciclasscode


