;this file is included in boot2.s

;***************************************************
; irq0
; PIT: Programmable Interrupt Timer
; this is the interrupt service routine for the pit
; referred to as the 8253 controller 
; see pic.s which initializes the pit
; and sets the firing rate
;******************************************


irq0:  
	cli	  ;disable interrupts
	push eax

	;count up to 0xffffffff then 
	;roll over to 0 and continue
	inc dword [PITCOUNTER]

	;end of interrupt
	mov al,0x20 
	out 0x20,al  
	
	pop eax	 ;preserve
	sti  ;enable interrupts
	iret  


