

;*********************************************************
;atol
;convert decimal string to dword in eax
;eax = address of string
;ecx = string length
;success: eax = string converted to dword in eax
;failure: eax = 0
;looks for valid char ascii 0x30-0x39 (0-9) only
;ignores leading and trailing invalid char
;starts at far right and moves left
;usage: convert keyboard entry of a decimal number
;*********************************************************

atol: 
	push esi
	push ebx
	push edx
	push ebp
	push edi
	
	lea esi,[eax+ecx-1]  ;esi points to end of string
	inc ecx              ;loop needs this to handle msbyte
	std                  ;decrement esi

.1:	lodsb        ;esi->al
	MAC_ISDIGIT  ;test al for ascii char, failure if zf=1
	loopz .1     ;if not ascii and ecx not 0

	;if ecx is 0 we failed to find a valid ascii
	cmp ecx,0
	jz .4

	;conversion to decimal 
	;multiply by 1,10,100,1000...
	inc esi      ;lodsb goes 1 too far
	xor ebx,ebx  ;zero out result
	xor edx,edx  ;zero out upper bits for mul
	mov edi,10   ;powers of 10 multiplier
	mov ebp,1    ;holds 1,10,100,1000... multiplier
	std          ;want lodsb to decrement (move left)

.2:	xor eax,eax  ;lodsb does not zero out first
	lodsb        ;mov next byte at esi to al
	MAC_ISDIGIT  ;test al for ascii
	jz .3        ;done 
	sub al,0x30  ;convert ascii to num
	mul ebp      ;eax * power of 10
	add ebx,eax  ;store result
	
	;increase multiplier by 10
	mov eax,ebp
	mul edi      ;eax *= 10
	mov ebp,eax  
	loop .2      ;dec ecx, jmp if not 0
	
.3:	mov eax,ebx  ;success, return dword 
	jmp .5
.4:	mov eax,0    ;we failed
.5:	
	pop edi
	pop ebp
	pop edx
	pop ebx
	pop esi
	ret



