
;***************************************
;dumpmem
;display 16 bytes of memory 
;as a series of ascii hex bytes

;ebx = X start
;eax = Y start
;esi = starting address
;ebp = qty bytes to display

;a dword such as 0x12345678
;will appear as: 78 56 34 12
;***************************************

dumpmem:
	pushad
	cmp ebp,0
	jz near .done
	mov dword [_x],ebx	
	mov dword [_y],eax	

.1:
	;hi nibble
	movzx eax,byte[esi]  ;get the byte
	shr eax,4  

	;conversion to ascii hex
	cmp al,10
	sbb al,69h
	das  ;al contains the ascii char
	
	;display the char
	mov ecx,eax
	mov ebx,[_x]
	mov eax,[_y]
	mov edx,0xeffe
	call putc



	;low nibble
	movzx eax,byte[esi]  ;get the byte
	and eax,0xf

	cmp al,10
	sbb al,69h
	das  ;al contains the ascii char
	
	mov ecx,eax
	add dword [_x],10
	mov ebx,[_x]
	mov eax,[_y]
	mov edx,0xeffe
	call putc

	;prepare for next byte in memory
	inc esi     ;move over to next byte
	add dword [_x],15  ;space between next byte
	cmp dword [_x],780
	jb .2
	mov dword [_x],0  ;left margin
	add dword [_y],20 ;next line down
.2:	dec ebp
	jnz .1

.done:
	popad
	ret

