

;**************************************************
;dumpreg
;no arguments
;text is displayed white on black
;starting on upper left corner of screen
;displays contents of (8) 32bit registers
;plus some flags
;**************************************************

_yloc dd 0
_dumpregbuf times 33 db 0
_editag db 'edi',0
_esitag db 'esi',0
_ebptag db 'ebp',0
_esptag db 'esp',0
_ebxtag db 'ebx',0
_edxtag db 'edx',0
_ecxtag db 'ecx',0
_eaxtag db 'eax',0
_eiptag db 'eip',0
_ZFtag db 'ZF',0
_OFtag db 'OF',0
_DFtag db 'DF',0
_IFtag db 'IF',0
_SFtag db 'SF',0
_CFtag db 'CF',0
_flags dd 0
_nextinstr dd 0


_dumpregtable:
dd _editag, _esitag, _ebptag, _esptag, 
dd _ebxtag, _edxtag, _ecxtag, _eaxtag
dd _eiptag


dumpreg:

	mov dword [_yloc],0

	pop dword [_nextinstr]    ;for displaying eip
	push dword [_nextinstr]   ;put it back

	pushad  ;preserved
	pushfd  ;flags preserved

	pushfd
	pop dword [_flags]  ;save for later
	
	;we will pop 9x
	push dword [_nextinstr]   ;eip will be displayed last
	pushad  ;8 gen purpose reg
	
	mov esi,0 ;outer loop counter

	;get next item off stack 
.1:	pop ebx   ;we will do 9 pops
	rol ebx,4
	mov ecx,8 ;8 char to display dword, inner loop counter
	mov ebp,0
		
		;inner loop
	.2  mov eax,ebx 
		
		;mask off all but low nibble
		and eax,0x0000000f  
		
		;convert al to ascii
		;code from John Eckerdahl (clever)
		cmp al,10
		sbb al,69h
		das

		;ascii char is in al
		mov byte [_dumpregbuf+ebp],al

		rol ebx,4
		inc ebp
		loop .2

	push esi 
	push ebx

	;tag
	lea esi,[_dumpregtable + esi*4  ]
	mov esi,[esi]
	mov ebx,0 ;x
	mov eax,[_yloc]
	mov dx,0xfeef  ;white on black
	call puts      ;print the tag e.g. "eax"
	
	;register value
	mov byte [_dumpregbuf+32],0   ;0 terminator
	mov esi,_dumpregbuf
	mov ebx,35  ;x
	call puts   ;print the register value as hex

	pop ebx
	pop esi
	

	;prepare for next item
	add dword [_yloc],20  ;move y down
	inc esi    ;inc outer loop counter
	cmp esi,9  ;9 items popped off stack
	jnz .1
	;end outer loop




	;now do flags	


	;carry flag
	mov ebx,0	
	add eax,20   ;mov Y down 
	mov esi,_CFtag
	mov cl,0
	call printflag


	;zero flag
	mov ebx,40	
	mov esi,_ZFtag
	mov cl,6
	call printflag


	;sign flag
	mov ebx,80	
	mov esi,_SFtag
	mov cl,7
	call printflag
	

	;interrupt flag
	;start a new row
	mov ebx,0
	add eax,20   ;mov Y down 
	mov esi,_IFtag
	mov cl,9
	call printflag



	;direction flag
	mov ebx,40
	mov esi,_DFtag
	mov cl,10
	call printflag


	;overflow flag
	mov ebx,80	
	mov esi,_OFtag
	mov cl,11
	call printflag

	

	mov dword [_yloc],0
	popfd
	popad


	;eip
	;address of next instruction should be on top of stack

	
	ret
	


;prints tag followed by value of flag
;e.g. ZF1  (zero flag set)
;e.g. OF0  (overflow flag clear)
;first set xloc (ebx) and yloc (eax) ahead of time
;esi=address of 2 char tag
;cl=number of bits to shift right
;to move desired flag to bit0
;cf=bit0 (shr 0)
;zf=bit6 (shr 6)
;sf=bit7 (shr 7)
;if=bit9 (shr 9)
;df=bit10 (shr 10)
;of=bit11 (shr 11)

printflag:
	call puts       ;print the tag
	mov edi,[_flags] 
	shr edi,cl      ;move desired flag to bit0
	and edi,1       ;mask of all but bit0
	add edi,0x30    ;convert to ascii
	add ebx,20      ;xloc for 0/1 after tag
	mov ecx,edi     ;putc needs ascii in ecx
	call putc
	ret


