

;***************************************************
; getbitmap
; copy a rectangular pattern of bits from video memory
; for restoring background after drawing operations
; this is the same code as putbitmap
; with esi/edi reversed
; ebx = xstart - upper left col, pixel
; eax = ystart - upper left row, pixel
; ecx = width,pixels 
; ebp = height,pixels
; edi = address to store bitmap bits
;***************************************************

getbitmap:
	pushad
	
	push edi
	MAC_GETPIXAD ebx,eax
	mov esi,edi    ;esi holds address in video buffer of 1st pix
	pop edi

	mov edx,[BPSL] ;bytesperscanline
	sub edx,ecx  
	;edx hold qty bytes to advance video buffer to next row

	cld         ;increment
	mov ebx,ecx ;save a copy of width

	;get pixels 1 at a time
.1:	rep movsb    ;esi->edi set entire row of pixels
	dec ebp      ;one less row
	je .2
	add esi,edx  ;increment video buffer to next row
	mov ecx,ebx  ;rep destroys ecx so restore for next row
	jmp .1

.2:	popad
	ret


