;this version has a bunch of call [swapbuf]



;***********************************************************
;gets
;get keypress and store in buffer
;quit on enter key 
;this is a single line edit control
;returns the qty key presses in eax
;max char is 80 based on size of 
;allocated memory to restore background 

;ebx = xloc of starting char 
;eax = yloc of starting char
;edi = address of buffer to store string
;ecx = max qty chars to store includes 0 terminator

;in this function edi always points to the char at the carrot 
;and _x holds the position on the screen of the carrot
;colors are black text on white 0xf7fe
;at the carrot reverse video = 0xfef7

;there is no rectangle drawn for background
;the characters will draw over top of whatever is there
;and the background will be restored (getbitmap/putbitmap)
;after the ENTER key is pressed
;if you want to draw a background rect first
;the size should be 15 pixels hi and
;width = 10*qtychar (each char is 8 width + 2 space)
;***********************************************************

_maxchar  dd 0
_qtykeypress dd 0
_xstart dd 0
_xend dd 0
_x dd 0
_y dd 0
_startaddress dd 0
_endaddress dd 0
_ten dd 10
_getswidth dd 0
_space db ' '
;background bitmap
;80charmax * 10 pixels wide * 15 pixels hi
_getsbackground times 80*10*15 db 0


gets:
	pushad

	;local variables
	mov dword [_xstart],ebx
	mov dword [_x],ebx
	mov dword [_y],eax
	mov dword [_startaddress],edi

	;_maxchar is number of printable char allowed
	;allow 1 less than specified for 0 terminator
	dec ecx 
	mov dword [_maxchar],ecx

	;test if we exceed 80 for our background bitmap
	cmp ecx,80
	jb .1
	mov eax,0
	jmp .error


	;endaddress is the last printable char
	;endaddress = startaddress + _maxchar - 1
.1:	mov ebx,edi
	add ebx,ecx
	sub ebx,1
	mov dword [_endaddress],ebx



	;_xend is pixel location of last printable char
	;it corresponds with _endaddress
	mov eax,ecx
	mul dword[_ten]
	mov dword[_getswidth],eax ;save width of edit field
	sub eax,10
	add eax,[_x]
	mov dword [_xend],eax

	;save background bitmap for restore on ENTER
	mov ebx,[_xstart]
	mov eax,[_y]
	mov ecx,[_getswidth]
	mov ebp,15
	mov edi,_getsbackground
	call getbitmap


	;fill buffer with spaces
	cld
	mov ecx,[_maxchar]
	mov al,' '
	mov edi,[_startaddress]
	rep stosb
	mov edi,[_startaddress]

	
	;carrot,reverse video, text white on dkgray background
	mov ebx,[_x]
	mov eax,[_y]
	mov edx,0xfef7
	movzx ecx,byte [edi]
	call putc
	call swapbuf



.gets_mainloop:

	;wait for irq1 to give us the keypress
	;the byte is stored at address 0x504
	;see keyboard.s
	cmp byte [0x504],0
	je .gets_mainloop


;ENTER key
	cmp byte [0x504],ENTER
	je near .done



;HOME key
	cmp byte [0x504],HOME
	jnz .end
	
	;show the current char as normal
	mov ebx,[_x]
	mov eax,[_y]
	mov edx,0xf7fe
	movzx ecx,byte [edi]
	call putc
	call swapbuf


	mov edi,[_startaddress]
	mov eax,[_xstart]
	mov [_x],eax
	
	;show first char as reverse video
	mov ebx,[_x]
	mov eax,[_y]
	mov edx,0xf7fe
	movzx ecx,byte [edi]
	call putc
	call swapbuf


	jmp .showcarrot




.end:
	cmp byte [0x504],END
	jnz .delete

	;show the current char as normal
	mov ebx,[_x]
	mov eax,[_y]
	mov edx,0xf7fe
	movzx ecx,byte [edi]
	call putc
	call swapbuf


	mov edi,[_endaddress]
	mov eax,[_xend]
	mov [_x],eax
	
	;show last char as reverse video
	mov ebx,[_x]
	mov eax,[_y]
	mov edx,0xfef7
	movzx ecx,byte [edi]
	call putc
	call swapbuf


	jmp .reset




.delete:
	cmp byte [0x504],DELETE
	jnz near .backspace

	
	mov ecx,[_endaddress] 
	sub ecx,edi  
	add ecx,1
	;ecx holds qty bytes to move left
	cld
	mov esi,edi
	add esi,1 
	push edi  ;preserve
	rep movsb ;slide everything left 1 char
	pop edi

	;the last char gets a space
	mov eax,[_endaddress]
	mov byte [eax],' '

	
	push edi ;perserve
	push dword [_x] ;preserve
	add edi,1
	add dword [_x],10
	mov edi,[_startaddress]
	mov eax,[_xstart]
	mov [_x],eax
	mov ebp,[_maxchar]

	;redraw the entire string
	.del_refresh:
	
		mov ebx,[_x]
		mov eax,[_y]
		mov edx,0xf7fe
		movzx ecx,byte [edi]
		call putc
		call swapbuf


		sub ebp,1
		jz .del_cleanup
		add edi,1
		add dword [_x],10
		jmp .del_refresh

	.del_cleanup
	pop dword [_x]
	pop edi

	;refresh carrot char
	mov ebx,[_x]
	mov eax,[_y]
	mov edx,0xfef7
	movzx ecx,byte [edi]
	call putc
	call swapbuf

	
	jmp .reset





.backspace:
	;same as delete except 
	;the char b4 the carrot is removed
	cmp byte [0x504],BKSPACE
	jnz near .leftarrow
		
	;no affect if carrot is at 1st char
	mov eax,[_xstart]
	cmp eax,[_x]
	jz near .reset
		

	;carrot will move 1 left
	sub dword [_x],10
	sub edi,1

	mov ecx,[_endaddress] 
	sub ecx,edi  
	add ecx,1
	;ecx holds qty bytes to move left
	cld
	mov esi,edi
	add esi,1 
	push edi  ;preserve
	rep movsb ;slide everything left 1 char
	pop edi

	;the last char gets a space
	mov eax,[_endaddress]
	mov byte [eax],' '

	
	push edi ;perserve
	push dword [_x] ;preserve
	add edi,1
	add dword [_x],10
	mov edi,[_startaddress]
	mov eax,[_xstart]
	mov [_x],eax
	mov ebp,[_maxchar]

	;redraw the entire string
	.back_refresh:
	
		mov ebx,[_x]
		mov eax,[_y]
		mov edx,0xf7fe
		movzx ecx,byte [edi]
		call putc
		call swapbuf


		sub ebp,1
		jz .back_cleanup
		add edi,1
		add dword [_x],10
		jmp .back_refresh

	.back_cleanup
	pop dword [_x]
	pop edi

	;refresh carrot char
	mov ebx,[_x]
	mov eax,[_y]
	mov edx,0xfef7
	movzx ecx,byte [edi]
	call putc
	call swapbuf


	jmp .reset




.leftarrow:
	cmp byte [0x504],LEFT
	jnz .rightarrow

	;dont backup beyond xorg
	mov eax,[_x]
	cmp eax,[_xstart]
	jz near .showcarrot

	;show the current char as normal
	mov ebx,[_x]
	mov eax,[_y]
	mov edx,0xf7fe
	movzx ecx,byte [edi]
	call putc
	call swapbuf


	dec edi
	sub dword [_x],10
	jmp .showcarrot



.rightarrow:
	cmp byte [0x504],RIGHT
	jnz .functionkeys
	
	;show the current char as normal
	mov ebx,[_x]
	mov eax,[_y]
	mov edx,0xf7fe
	movzx ecx,byte [edi]
	call putc
	call swapbuf


	;are we at end of string
	mov eax,[_xend]
	cmp eax,[_x]
	jz near .showcarrot

	;increment things
	inc edi
	add dword [_x],10
	jmp .showcarrot



.functionkeys:
	;filter out
	cmp byte [0x504],F12
	jae .ctrl 
	cmp byte [0x504],F1
	jb near .printablekey
	jmp .reset

.ctrl
	;filter out
	cmp byte [0x504],CTRL
	je near .reset

	cmp byte [0x504],ALT
	je near .reset

	cmp byte [0x504],NUM
	je near .reset
	
	cmp byte [0x504],TAB
	je near .reset

	cmp byte [0x504],UP
	je near .reset

	cmp byte [0x504],PAGEUP
	je near .reset


	cmp byte [0x504],CENTER
	je near .reset

	cmp byte [0x504],DOWN
	je near .reset

	cmp byte [0x504],PAGEDN
	je near .reset

	cmp byte [0x504],INSERT
	je near .reset
	
	cmp byte [0x504],PRNTSCR
	je near .reset

	cmp byte [0x504],SCRLOCK
	je near .reset



	

.printablekey:
	;save the keypress to our string
	mov cl,[0x504]
	mov [edi],cl

	;display the keypress as normal (dkgray on white)
	mov ebx,[_x]
	mov eax,[_y]
	mov edx,0xf7fe
	movzx ecx,byte [0x504]
	call putc
	call swapbuf


	;are we at end of string
	mov eax,[_xend]
	cmp eax,[_x]
	jz .showcarrot

	;increment things
	inc dword [_qtykeypress] 
	add dword [_x],8+2
	inc edi        ;point to next char




.showcarrot:	
	;reverse video, text white on dkgray background
	mov ebx,[_x]
	mov eax,[_y]
	mov edx,0xfef7
	movzx ecx,byte [edi]
	call putc
	call swapbuf



.reset:
	;reset for another keypress
	mov byte [0x504],0

	jmp .gets_mainloop




.done: 
	;reset for subsequent read operations
	mov byte [0x504],0

	;find end of string
	mov ecx,[_maxchar]
	mov edi,[_endaddress]
.find_endofstring:
	cmp byte [edi],0x20
	ja .zero_terminate
	dec edi
	loop .find_endofstring

.zero_terminate:
	add edi,1
	mov byte [edi],0


	;restore the background bitmap
	mov ebx,[_xstart]
	mov eax,[_y]
	mov ecx,[_getswidth]
	mov ebp,15
	mov esi,_getsbackground
	call putbits
	call swapbuf



	;return value


.error:
	popad
	ret


