
;***************************************
;gettime
;get values from RealTimeClock
;CMOS RAM Bank 0
;returns an ascii string indicating "mm-dd-hh-mm"
;mm=2 byte month
;dd=2 byte day
;hh=2 byte hour
;mm=2 byte minute
;assumes conversion from BCD to ascii is reqd
;pass to this function the address of a buffer
;that is 12 bytes long in edi 
;string will be 0 terminated
;***************************************
gettime:
	push eax
	push ebx

.1:	mov al,0xa    ;RTC register A
	out 0x70,al
	in al,0x71
	test al,0x80 ;is update in progress
	jne .1


	;register B
	mov al,0xb
	out 0x70,al
	in al,0x71


	;bit1
	;bit=1,zf=0 = 24 hour mode
	;bit=0,zf=1 = 12 hour mode
	;test al,00000010b
	

	;bit2
	;if bit2=0,zf=1 we have BCD endcoding
	;if bit2=1,zf=0 we have binary
	;test al,00000100b
	;for now we just assume BCD



	;month
.5:	mov al,0x08
	out 0x70,al
	in al,0x71

	;convert first nibble from bcd to ascii
	movzx ebx,al
	shr ebx,4
	add ebx,0x30
	mov [edi],bl

	;second nibble
	movzx ebx,al
	and ebx,0xf
	add ebx,0x30
	mov [edi+1],bl

	mov byte [edi+2],'-'


	;day 
	mov al,0x07
	out 0x70,al
	in al,0x71

	movzx ebx,al
	shr ebx,4
	add ebx,0x30
	mov [edi+3],bl

	movzx ebx,al
	and ebx,0xf
	add ebx,0x30
	mov [edi+4],bl

	mov byte [edi+5],'-'



	;hours
	mov al,0x04
	out 0x70,al
	in al,0x71
	
	movzx ebx,al
	shr ebx,4
	add ebx,0x30
	mov [edi+6],bl

	movzx ebx,al
	and ebx,0xf
	add ebx,0x30
	mov [edi+7],bl

	mov byte [edi+8],'-'


	
	;minutes
	mov al,0x02
	out 0x70,al
	in al,0x71

	movzx ebx,al
	shr ebx,4
	add ebx,0x30
	mov [edi+9],bl

	movzx ebx,al
	and ebx,0xf
	add ebx,0x30
	mov [edi+10],bl



	;null terminate
	mov byte [edi+11],0

	pop ebx
	pop eax
	ret


