
;***********************************
;hline
;draws a horizontal line 1 pixel wide
;left to right
;ebx = xstart 
;eax = ystart 
;edx = length,pixels 
;esi = color index (0-255)
;**********************************

hline:
	pushad

	;compute address of first pixel in back buffer
	MAC_GETPIXAD ebx,eax

	mov ecx,edx
	mov ax,si    ;color to al
	cld          ;increment
	rep stosb    ;al->edi set entire row of pixels

	popad
	ret


;***********************************
;vline
;draws a vertical line 1 pixel wide
;top down
;ebx = xstart 
;eax = ystart 
;edx = length,pixels 
;esi = color index (0-255)
;**********************************

vline:
	pushad

	;compute address of first pixel in back buffer
	MAC_GETPIXAD ebx,eax

	mov ebp,[BPSL] 
	;ebp now holds qty bytes to advance video buffer to next row

	mov ecx,edx
	mov ax,si    ;color to al
	cld          ;increment

.1:	mov [edi],al  
	add edi,ebp
	loop .1

	popad
	ret



