;*****************************************
;puteax
;display contents of eax 
;as dword ascii hex
;3 key lines of code from John Eckerdahl
;ebx = xloc,pixel 
;ecx = yloc,pixel 
; dh = text color (0-0xff)
; dl = bk color (0-0xff)
;edi = 0 to display eax
;      1 to display  ax
;      2 to display  al  
;****************************************

puteax:
	pushad 

	mov dword [_yloc],ecx ;local variable
	mov esi,8  ;to display the entire eax we need 8 nibbles

	cmp edi,0
	jz .2
	cmp edi,2
	jz .1
	
    ;to display ax
	rol eax,16 ;mov ax up to hi 16 bits of eax
	mov esi,4  ;display 4 nibbles
	jmp .2
	
	
    ;to display al
.1:	rol eax,24 ;mov al up to hi 8 bits of eax
	mov esi,2  ;display 2 nibble
 

	;get the first nibble ready
.2:	rol eax,4
	mov ebp,eax ;save a copy 
	and eax,0xf



.3: ;loop esi times

	;this is the amazing code that 
	;converts the nibble to ascii hex
	cmp al,10
	sbb al,69h
	das  ;al contains the ascii char
	
	;display the char
	mov ecx,eax
	mov eax,[_yloc]
	call putc

	;increment some things
	rol ebp,4
	mov eax,ebp 
	and eax,0xf  
	add ebx,10  ;x+10
	dec esi
	jnz .3

	popad
	ret
	




;****************************************************
;puteax10
;display contents of register eax 
;as a base 10 series of ascii bytes 
;any 0x0 bytes are ignored

;ebx = xloc,pixel 
;ecx = yloc,pixel 
; dh = text color (0-0xff)
; dl = bk color (0-0xff)
;****************************************************
_eaxbuf times 10 db 0

puteax10: 
	pushad         
	push ebx
	push ecx
	push edx

	MAC_MEMSET _eaxbuf,0,10,b   ;fill buffer with 0x0 bytes
	mov ebx,10                  ;our base (denominator)
	mov ecx,10                  ;loop count
	
.1:	;top of division loop
	xor edx,edx  ;zero out
	div ebx      ;eax/ebx, quotient in eax, remainder in edx
	add edx,0x30 ;convert to ascii
	;dl contains the ascii char

	;store and increment
	mov [_eaxbuf+ecx-1],dl   ;store in buf from right to left
	cmp eax,0             ;were done if quotient is 0
	loopnz .1             ;ecx not 0 and zf not set


	;print out the ascii char
	;left to right
	;ignore leading 0x0 bytes
	pop edx
	pop eax
	pop ebx
	xor ecx,ecx
	mov esi,_eaxbuf
	mov ebp,10   ;counter
	
.2:	movzx ecx,byte [esi] ;fetch ascii byte
	cmp ecx,0     ;test for 0x0 byte 
	jz .3
	call putc
	add ebx,10  ;x+10 
.3:	inc esi     ;get next ascii byte
	dec ebp
	jnz .2

	popad 
	ret

	

