

;****************************************************	
;puts
;display an ascii string in 800x600x8bpp graphics mode
;string must be terminated with zero 0
;will wrap to next line if necessary
;assumes use of 9x15font.inc

;ebx = xloc,pixel 
;eax = yloc,pixel 
;esi = starting address of 0 terminated string
; dh = text color
; dl = bk color (0-0xff)

;****************************************************	

puts:
	pushad
	xor ecx,ecx
	cld          ;inc
	
.1:	mov cl,[esi] ;fetch ascii byte
	cmp cl,0     ;test for 0 terminator
	je .done
	call putc
	inc esi      ;get next ascii byte

    ;advance to location of next char bitmap
	;equal to width of bitmap + space inbetween
	add bx,8+2   

	;wrap text to next line if reqd
	cmp ebx,790
	jbe .1
	mov ebx,0
	add eax,15
	
	jmp .1

.done
	popad
	ret




;this function does not need a terminating 0
;but the bytes in memory must be ascii
;see dumpmem and dumpmemn for non-ascii 

;ebx = xloc,pixel 
;eax = yloc,pixel 
;esi = starting address of memory to display as ascii
;ecx = qty bytes to display
; dh = text color
; dl = bk color (0-0xff)


putsn:
	pushad
	cld          ;inc

	;nothing to display
	cmp ecx,0
	jz .done

.1:
	push ecx	 ;push the qty bytes because we need ecx
	movzx ecx,byte [esi] ;fetch ascii byte
	call putc
	inc esi      ;get next ascii byte

    ;advance to location of next char bitmap
	;equal to width of bitmap + space inbetween
	add bx,8+2   

	;wrap text to next line if reqd
	cmp ebx,790
	jbe .2
	mov ebx,0
	add eax,15
.2:	
	pop ecx
	loop .1

.done
	popad
	ret





