
;***********************************************
;sleep
;makes use of pit counter value @ PITCOUNTER
;to pause execution of time sensitive graphics

;eax=amount of milliseconds to pause

;set eax=1000 to pause for one second
;you can make a simple clock just by displaying 
;a number then sleep(1000) then increment and loop
;see interrupts.s which programs the PIT to
;fire appx once every millisecond
;see also pic.s which must enable the PIT interrupt

;warning: dont call this function while interrupts
;are disabled (cli). It will hang your computer !
;************************************************

sleep:
	push ebx

	mov ebx,[PITCOUNTER] ;get value of pit counter
	add ebx,eax     ;ebx=value of pit counter + amount of delay

.1:	mov eax,[PITCOUNTER] ;get value of pit counter again
	cmp ebx,eax     ;are we there yet ?
	ja .1           ;no-keep checking

	pop ebx
	ret
