
;swapbuf
;this function is called at the end of a paint cycle
;to copy the back buffer to video memory
;for 800x600x8bpp
;no arguments
;the mouse cursor is also drawn here
;you can draw to the screen from any subroutine
;by just calling puts or whatever and then call swapbuf



swapbuf:
	pushad
		
	MAC_GETPIXAD [MOUSEX],[MOUSEY] 
	;edi holds address of mouse image pick point 

	mov ebx,[BPSL]  



;**************************************************
;draw the mouse arrow
;its hardcoded
;this is a 12x21 bitmap of the traditional arrow pointer
;based on an image from www.wpclipart.com/computer/mouse
;0xef is the dac entry for black and 0xef is white
;**************************************************
	

	;row1
	;this is the mouse point pixel
	mov byte [edi], BLA      
	
	;row2
	add edi,ebx
	mov word [edi],0xefef   ;black, black
	
	;row3
	add edi,ebx
	mov word [edi],0xfeef   
	mov byte [edi+2], BLA   

	;row4
	add edi,ebx
	mov dword [edi], 0xeffefeef

	;row5
	add edi,ebx
	mov dword [edi], 0xfefefeef
	mov byte [edi+4], BLA   

	;row6
	add edi,ebx
	mov dword [edi], 0xfefefeef
	mov word [edi+4],0xeffe   

	;row7
	add edi,ebx
	mov dword [edi], 0xfefefeef
	mov word [edi+4],0xfefe   
	mov byte [edi+6], BLA   

	;row8
	add edi,ebx
	mov dword [edi], 0xfefefeef
	mov dword [edi+4], 0xeffefefe

	;row9
	add edi,ebx
	mov dword [edi], 0xfefefeef
	mov dword [edi+4], 0xfefefefe
	mov byte [edi+8], BLA   

	;row10
	add edi,ebx
	mov dword [edi], 0xfefefeef
	mov dword [edi+4], 0xfefefefe
	mov word [edi+8], 0xeffe   

	;row11
	add edi,ebx
	mov dword [edi], 0xfefefeef
	mov dword [edi+4], 0xfefefefe
	mov word [edi+8], 0xfefe   
	mov byte [edi+10], BLA   

	;row12
	add edi,ebx
	mov dword [edi], 0xfefefeef
	mov dword [edi+4], 0xfefefefe
	mov dword [edi+8], 0xeffefefe

	;row13
	add edi,ebx
	mov dword [edi], 0xfefefeef
	mov dword [edi+4], 0xeffefeef

	;row14
	add edi,ebx
	mov dword [edi], 0xeffefeef
	mov dword [edi+4], 0xeffefeef

	;row15
	add edi,ebx
	mov word [edi], 0xfeef   
	mov byte [edi+2], BLA   
	mov dword [edi+5], 0xeffefeef

	;row16
	add edi,ebx
	mov word [edi], 0xefef   
	mov dword [edi+5], 0xeffefeef

	;row17
	add edi,ebx
	mov byte [edi], BLA   
	mov dword [edi+6], 0xeffefeef

	;row18
	add edi,ebx
	mov dword [edi+6], 0xeffefeef

	;row19
	add edi,ebx
	mov dword [edi+7], 0xeffefeef

	;row20
	add edi,ebx
	mov dword [edi+7], 0xeffefeef

	;row21
	add edi,ebx
	mov word [edi+8], 0xefef   



	;********************************************************
	;swap the buffers
	;someone on the web pointed me to the movq instruction
	;movb or movd are just too slow
	;the idea is to grab as much data as possible in one shot
	;and minimize the number of writes to memory for speed
	;********************************************************

.swap:
	;set up for moving 64 bytes at a time
	mov esi, BACKBUF   ;backbuffer
	mov edi, [LFB]     ;linear frame buffer
	mov ecx, [BPSL64]  ;sizeof video buffer/64
	
.2:
	;grap 64 bytes using MMX registers
	movq mm0, [esi]
	movq mm1, [esi+8]
	movq mm2, [esi+16]
	movq mm3, [esi+24]
	movq mm4, [esi+32]
	movq mm5, [esi+40]
	movq mm6, [esi+48]
	movq mm7, [esi+56]

	;copy to LFB
	movq [edi], mm0
	movq [edi+8], mm1
	movq [edi+16], mm2
	movq [edi+24], mm3
	movq [edi+32], mm4
	movq [edi+40], mm5
	movq [edi+48], mm6
	movq [edi+56], mm7

	add esi,64
	add edi,64
	loop .2


	popad
	ret




